Imports System.Reflection
Imports System.CodeDom.Compiler
Imports Microsoft.VisualBasic
Imports System.IO

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents btnRun As System.Windows.Forms.Button
    Friend WithEvents txtSourceCode As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnRun = New System.Windows.Forms.Button
        Me.txtSourceCode = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'btnRun
        '
        Me.btnRun.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnRun.Location = New System.Drawing.Point(496, 320)
        Me.btnRun.Name = "btnRun"
        Me.btnRun.Size = New System.Drawing.Size(80, 32)
        Me.btnRun.TabIndex = 0
        Me.btnRun.Text = "Run Code"
        '
        'txtSourceCode
        '
        Me.txtSourceCode.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtSourceCode.Location = New System.Drawing.Point(16, 32)
        Me.txtSourceCode.Multiline = True
        Me.txtSourceCode.Name = "txtSourceCode"
        Me.txtSourceCode.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtSourceCode.Size = New System.Drawing.Size(568, 280)
        Me.txtSourceCode.TabIndex = 1
        Me.txtSourceCode.Text = ""
        Me.txtSourceCode.WordWrap = False
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(177, Byte))
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(152, 16)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "VB.NET Code:"
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(592, 366)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.txtSourceCode)
        Me.Controls.Add(Me.btnRun)
        Me.Name = "frmMain"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Dynamic VB.NET Code"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click
        '
        ' Instantiate the VB compiler.
        '
        Dim objCodeCompiler As ICodeCompiler = New VBCodeProvider().CreateCompiler

        '
        ' Pass parameters into the compiler.
        '
        Dim objCompilerParameters As New CompilerParameters
        objCompilerParameters.ReferencedAssemblies.Add("System.dll")
        objCompilerParameters.ReferencedAssemblies.Add("System.Windows.Forms.dll")
        objCompilerParameters.ReferencedAssemblies.Add("Microsoft.VisualBasic.dll")
        objCompilerParameters.GenerateInMemory = True

        '
        ' Get te source code and compile it.
        '
        Dim strCode As String = txtSourceCode.Text
        Dim objCompileResults As CompilerResults = objCodeCompiler.CompileAssemblyFromSource(objCompilerParameters, strCode)

        '
        ' Check for compiler errors.
        '
        If objCompileResults.Errors.HasErrors Then
            MsgBox("Error: Line>" & objCompileResults.Errors(0).Line.ToString & ", " & objCompileResults.Errors(0).ErrorText)
            Exit Sub
        End If

        '
        ' Get a reference to the assembly.
        '
        Dim objAssembly As System.Reflection.Assembly = objCompileResults.CompiledAssembly

        '
        ' Create an instance of the DynamicCode class referenced in the source code.
        '
        Dim objTheClass As Object = objAssembly.CreateInstance("Dynam.DynamicCode")

        If objTheClass Is Nothing Then
            MessageBox.Show("Unable to load class.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        '
        ' Create a parameter to be passed into the ExecuteCode function in class DynamicCode.
        '
        Dim objFunctionParameters(0) As Object
        objFunctionParameters(0) = "Parameter 1"

        '
        ' Call the DynamicCode.ExecuteCode
        '
        Try
            Dim objResult As Object = objTheClass.GetType.InvokeMember("ExecuteCode", _
                            BindingFlags.InvokeMethod, Nothing, objTheClass, objFunctionParameters)

            MessageBox.Show(objResult.ToString())

        Catch ex As Exception
            MessageBox.Show("Error:" & ex.Message)
        End Try

    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '
        ' Read in the source code from the text file.
        '
        Dim objStream As New StreamReader(Application.StartupPath & "\SourceCode.txt")
        txtSourceCode.Text = objStream.ReadToEnd
        objStream.Close()

    End Sub
End Class
